# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`telegraf`](#telegraf): A Puppet module for installing InfluxData's Telegraf
* [`telegraf::config`](#telegraf--config): == Class: telegraf::config  Templated generation of telegraf.conf
* [`telegraf::install`](#telegraf--install): == Class: telegraf::install  Conditionally handle InfluxData's official repos and install the necessary Telegraf package.
* [`telegraf::params`](#telegraf--params): == Class: telegraf::params  A set of default parameters for Telegraf's configuration.
* [`telegraf::service`](#telegraf--service): == Class: telegraf::service  Optionally manage the Telegraf service.

### Defined types

* [`telegraf::aggregator`](#telegraf--aggregator): A Puppet wrapper for discrete Telegraf aggregator files
* [`telegraf::input`](#telegraf--input): A Puppet wrapper for discrete Telegraf input files
* [`telegraf::output`](#telegraf--output): A Puppet wrapper for discrete Telegraf output files
* [`telegraf::processor`](#telegraf--processor): A Puppet wrapper for discrete Telegraf processor files

## Classes

### <a name="telegraf"></a>`telegraf`

A Puppet module for installing InfluxData's Telegraf

#### Parameters

The following parameters are available in the `telegraf` class:

* [`package_name`](#-telegraf--package_name)
* [`ensure`](#-telegraf--ensure)
* [`config_file`](#-telegraf--config_file)
* [`logfile`](#-telegraf--logfile)
* [`logfile_rotation_interval`](#-telegraf--logfile_rotation_interval)
* [`logfile_rotation_max_size`](#-telegraf--logfile_rotation_max_size)
* [`logfile_rotation_max_archives`](#-telegraf--logfile_rotation_max_archives)
* [`config_file_owner`](#-telegraf--config_file_owner)
* [`config_file_group`](#-telegraf--config_file_group)
* [`config_file_mode`](#-telegraf--config_file_mode)
* [`config_folder`](#-telegraf--config_folder)
* [`config_folder_mode`](#-telegraf--config_folder_mode)
* [`hostname`](#-telegraf--hostname)
* [`omit_hostname`](#-telegraf--omit_hostname)
* [`interval`](#-telegraf--interval)
* [`round_interval`](#-telegraf--round_interval)
* [`metric_batch_size`](#-telegraf--metric_batch_size)
* [`metric_buffer_limit`](#-telegraf--metric_buffer_limit)
* [`collection_jitter`](#-telegraf--collection_jitter)
* [`flush_interval`](#-telegraf--flush_interval)
* [`flush_jitter`](#-telegraf--flush_jitter)
* [`debug`](#-telegraf--debug)
* [`quiet`](#-telegraf--quiet)
* [`outputs`](#-telegraf--outputs)
* [`inputs`](#-telegraf--inputs)
* [`global_tags`](#-telegraf--global_tags)
* [`processors`](#-telegraf--processors)
* [`manage_service`](#-telegraf--manage_service)
* [`manage_repo`](#-telegraf--manage_repo)
* [`manage_archive`](#-telegraf--manage_archive)
* [`manage_user`](#-telegraf--manage_user)
* [`repo_location`](#-telegraf--repo_location)
* [`archive_location`](#-telegraf--archive_location)
* [`archive_version`](#-telegraf--archive_version)
* [`archive_install_dir`](#-telegraf--archive_install_dir)
* [`install_options`](#-telegraf--install_options)
* [`purge_config_fragments`](#-telegraf--purge_config_fragments)
* [`repo_type`](#-telegraf--repo_type)
* [`windows_package_url`](#-telegraf--windows_package_url)
* [`precision`](#-telegraf--precision)
* [`service_enable`](#-telegraf--service_enable)
* [`service_ensure`](#-telegraf--service_ensure)

##### <a name="-telegraf--package_name"></a>`package_name`

Data type: `String`

Package name

Default value: `$telegraf::params::package_name`

##### <a name="-telegraf--ensure"></a>`ensure`

Data type: `String`

State of the telegraf package. You can also specify a particular version to install

Default value: `$telegraf::params::ensure`

##### <a name="-telegraf--config_file"></a>`config_file`

Data type: `String`

Path to the configuration file

Default value: `$telegraf::params::config_file`

##### <a name="-telegraf--logfile"></a>`logfile`

Data type: `String`

Path to the log file

Default value: `$telegraf::params::logfile`

##### <a name="-telegraf--logfile_rotation_interval"></a>`logfile_rotation_interval`

Data type: `String`

The logfile will be rotated after the time interval specified, e.g. "1d". 0 = off. Default = "0h"

Default value: `$telegraf::params::logfile_rotation_interval`

##### <a name="-telegraf--logfile_rotation_max_size"></a>`logfile_rotation_max_size`

Data type: `String`

The logfile will be rotated when it becomes larger than the specified size, e.g. "10MB". 0 = off.  Default = "0MB"

Default value: `$telegraf::params::logfile_rotation_max_size`

##### <a name="-telegraf--logfile_rotation_max_archives"></a>`logfile_rotation_max_archives`

Data type: `Integer`

Maximum number of rotated archives to keep, older logs are deleted.  If set to -1, no archives are removed. Default = 5

Default value: `$telegraf::params::logfile_rotation_max_archives`

##### <a name="-telegraf--config_file_owner"></a>`config_file_owner`

Data type: `String`

User to own the telegraf config file

Default value: `$telegraf::params::config_file_owner`

##### <a name="-telegraf--config_file_group"></a>`config_file_group`

Data type: `String`

Group to own the telegraf config file

Default value: `$telegraf::params::config_file_group`

##### <a name="-telegraf--config_file_mode"></a>`config_file_mode`

Data type: `Optional[Stdlib::Filemode]`

File mode for the telegraf config file

Default value: `$telegraf::params::config_file_mode`

##### <a name="-telegraf--config_folder"></a>`config_folder`

Data type: `String`

Path of additional telegraf config folder

Default value: `$telegraf::params::config_folder`

##### <a name="-telegraf--config_folder_mode"></a>`config_folder_mode`

Data type: `Optional[Stdlib::Filemode]`

File mode for the telegraf config folder

Default value: `$telegraf::params::config_folder_mode`

##### <a name="-telegraf--hostname"></a>`hostname`

Data type: `String`

Override default hostname used to identify this agent

Default value: `$telegraf::params::hostname`

##### <a name="-telegraf--omit_hostname"></a>`omit_hostname`

Data type: `Boolean`

Do not set the "host" tag in the telegraf agent

Default value: `$telegraf::params::omit_hostname`

##### <a name="-telegraf--interval"></a>`interval`

Data type: `String`

Default data collection interval for all inputs

Default value: `$telegraf::params::interval`

##### <a name="-telegraf--round_interval"></a>`round_interval`

Data type: `Boolean`

Rounds collection interval to 'interval'

Default value: `$telegraf::params::round_interval`

##### <a name="-telegraf--metric_batch_size"></a>`metric_batch_size`

Data type: `Integer`

The maximum batch size to allow to accumulate before sending a flush to the configured outputs

Default value: `$telegraf::params::metric_batch_size`

##### <a name="-telegraf--metric_buffer_limit"></a>`metric_buffer_limit`

Data type: `Integer`

The absolute maximum number of metrics that will accumulate before metrics are dropped

Default value: `$telegraf::params::metric_buffer_limit`

##### <a name="-telegraf--collection_jitter"></a>`collection_jitter`

Data type: `String`

Sleep for a random time within jitter before collecting

Default value: `$telegraf::params::collection_jitter`

##### <a name="-telegraf--flush_interval"></a>`flush_interval`

Data type: `String`

Default flushing interval for all outputs

Default value: `$telegraf::params::flush_interval`

##### <a name="-telegraf--flush_jitter"></a>`flush_jitter`

Data type: `String`

Jitter the flush interval by an amount

Default value: `$telegraf::params::flush_jitter`

##### <a name="-telegraf--debug"></a>`debug`

Data type: `Boolean`

Run telegraf in debug mode

Default value: `$telegraf::params::debug`

##### <a name="-telegraf--quiet"></a>`quiet`

Data type: `Boolean`

Run telegraf in quiet mode

Default value: `$telegraf::params::quiet`

##### <a name="-telegraf--outputs"></a>`outputs`

Data type: `Hash`

Specify output plugins and their options

Default value: `$telegraf::params::outputs`

##### <a name="-telegraf--inputs"></a>`inputs`

Data type: `Hash`

Specify input plugins and their options

Default value: `$telegraf::params::inputs`

##### <a name="-telegraf--global_tags"></a>`global_tags`

Data type: `Hash`

Global tags as a key-value pair

Default value: `$telegraf::params::global_tags`

##### <a name="-telegraf--processors"></a>`processors`

Data type: `Hash`

Specify processors and their configuration

Default value: `{}`

##### <a name="-telegraf--manage_service"></a>`manage_service`

Data type: `Boolean`

Whether to manage the telegraf service or not

Default value: `$telegraf::params::manage_service`

##### <a name="-telegraf--manage_repo"></a>`manage_repo`

Data type: `Boolean`

Whether or not to manage InfluxData's repo

Default value: `$telegraf::params::manage_repo`

##### <a name="-telegraf--manage_archive"></a>`manage_archive`

Data type: `Boolean`

Whether or not to manage InfluxData's tar archive

Default value: `$telegraf::params::manage_archive`

##### <a name="-telegraf--manage_user"></a>`manage_user`

Data type: `Boolean`

Whether or not to manage the 'telegraf' user when installing from archive

Default value: `$telegraf::params::manage_user`

##### <a name="-telegraf--repo_location"></a>`repo_location`

Data type: `Optional[String]`

Alternate repo location. E.g. an interal mirror

Default value: `$telegraf::params::repo_location`

##### <a name="-telegraf--archive_location"></a>`archive_location`

Data type: `Optional[String]`

Alternate archive location. E.g. an interal mirror

Default value: `$telegraf::params::archive_location`

##### <a name="-telegraf--archive_version"></a>`archive_version`

Data type: `Optional[String[1]]`

Specify a telegraf archive version. E.g. 1.17.2

Default value: `$telegraf::params::archive_version`

##### <a name="-telegraf--archive_install_dir"></a>`archive_install_dir`

Data type: `Optional[String]`

Location to extract archive to must be an absolute path

Default value: `$telegraf::params::archive_install_dir`

##### <a name="-telegraf--install_options"></a>`install_options`

Data type: `Array`

Additional options to pass when installing package

Default value: `$telegraf::params::install_options`

##### <a name="-telegraf--purge_config_fragments"></a>`purge_config_fragments`

Data type: `Boolean`

Whether unmanaged configuration fragments should be removed

Default value: `$telegraf::params::purge_config_fragments`

##### <a name="-telegraf--repo_type"></a>`repo_type`

Data type: `String`

Which repo (stable, unstable, nightly) to use

Default value: `$telegraf::params::repo_type`

##### <a name="-telegraf--windows_package_url"></a>`windows_package_url`

Data type: `String`

URL for windows telegraf chocolatey repo

Default value: `$telegraf::params::windows_package_url`

##### <a name="-telegraf--precision"></a>`precision`

Data type: `String`



Default value: `$telegraf::params::precision`

##### <a name="-telegraf--service_enable"></a>`service_enable`

Data type: `Boolean`

enable state for the telegraf service

Default value: `$telegraf::params::service_enable`

##### <a name="-telegraf--service_ensure"></a>`service_ensure`

Data type: `String`

ensure state for the telegraf service

Default value: `$telegraf::params::service_ensure`

### <a name="telegraf--config"></a>`telegraf::config`

== Class: telegraf::config

Templated generation of telegraf.conf

### <a name="telegraf--install"></a>`telegraf::install`

== Class: telegraf::install

Conditionally handle InfluxData's official repos and install the necessary
Telegraf package.

### <a name="telegraf--params"></a>`telegraf::params`

== Class: telegraf::params

A set of default parameters for Telegraf's configuration.

### <a name="telegraf--service"></a>`telegraf::service`

== Class: telegraf::service

Optionally manage the Telegraf service.

## Defined types

### <a name="telegraf--aggregator"></a>`telegraf::aggregator`

A Puppet wrapper for discrete Telegraf aggregator files

#### Parameters

The following parameters are available in the `telegraf::aggregator` defined type:

* [`options`](#-telegraf--aggregator--options)
* [`plugin_type`](#-telegraf--aggregator--plugin_type)
* [`ensure`](#-telegraf--aggregator--ensure)

##### <a name="-telegraf--aggregator--options"></a>`options`

Data type: `Optional[Array]`

Plugin options for use in the aggregator template

Default value: `undef`

##### <a name="-telegraf--aggregator--plugin_type"></a>`plugin_type`

Data type: `String`

Define the telegraf plugin type to use

Default value: `$name`

##### <a name="-telegraf--aggregator--ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`

Set if the ensure params of the config file. If telegraf::ensure is absent the value is automatically absent

Default value: `'present'`

### <a name="telegraf--input"></a>`telegraf::input`

A Puppet wrapper for discrete Telegraf input files

#### Parameters

The following parameters are available in the `telegraf::input` defined type:

* [`options`](#-telegraf--input--options)
* [`plugin_type`](#-telegraf--input--plugin_type)
* [`ensure`](#-telegraf--input--ensure)

##### <a name="-telegraf--input--options"></a>`options`

Data type: `Array`

Plugin options for use in the input template.

Default value: `[]`

##### <a name="-telegraf--input--plugin_type"></a>`plugin_type`

Data type: `String`

Define the telegraf plugin type to use (default is $name)

Default value: `$name`

##### <a name="-telegraf--input--ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`

Set if the ensure params of the config file. If telegraf::ensure is absent the value is automatically absent

Default value: `'present'`

### <a name="telegraf--output"></a>`telegraf::output`

A Puppet wrapper for discrete Telegraf output files

#### Parameters

The following parameters are available in the `telegraf::output` defined type:

* [`options`](#-telegraf--output--options)
* [`plugin_type`](#-telegraf--output--plugin_type)
* [`ensure`](#-telegraf--output--ensure)

##### <a name="-telegraf--output--options"></a>`options`

Data type: `Optional[Array]`

Plugin options for use in the output template.

Default value: `undef`

##### <a name="-telegraf--output--plugin_type"></a>`plugin_type`

Data type: `String`

Define the telegraf plugin type to use (default is $name)

Default value: `$name`

##### <a name="-telegraf--output--ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`

Set if the ensure params of the config file. If telegraf::ensure is absent the value is automatically absent

Default value: `'present'`

### <a name="telegraf--processor"></a>`telegraf::processor`

A Puppet wrapper for discrete Telegraf processor files

#### Parameters

The following parameters are available in the `telegraf::processor` defined type:

* [`options`](#-telegraf--processor--options)
* [`plugin_type`](#-telegraf--processor--plugin_type)
* [`ensure`](#-telegraf--processor--ensure)

##### <a name="-telegraf--processor--options"></a>`options`

Data type: `Optional[Array]`

Plugin options for use in the processor template

Default value: `undef`

##### <a name="-telegraf--processor--plugin_type"></a>`plugin_type`

Data type: `String`

Define the telegraf plugin type to use

Default value: `$name`

##### <a name="-telegraf--processor--ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`

Set if the ensure params of the config file. If telegraf::ensure is absent the value is automatically absent

Default value: `'present'`

